<?php /* $Id */
//Copyright (C) 2011 Nicolas Gudino <asternic@gmail.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of version 2 the GNU General Public
//License as published by the Free Software Foundation.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.


$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
$itemid = isset($_REQUEST['itemid'])?$_REQUEST['itemid']:'';
$dispnum = "fop2plugins";
$type='tool';

$tabindex=0;

$licensedplugins=explode(',',getPlugins());

$fop2_mirror = getFastestMirror();

if($action=='getplugin') {

    fop2_downloadPlugin($itemid, $fop2_mirror);

} else if($action=='upload') {

    $res = plugin_handleupload($_FILES['uploadplug']);
    if (is_array($res)) {
        echo '<div class="error"><p>';
        echo sprintf(_('The following error(s) occurred processing the uploaded file: %s'), 
             '<ul><li>'.implode('</li><li>',$res).'</li></ul>');
        echo sprintf(_('You should fix the problem or select another file and %s.'), 
             "<a href='config.php?display=fop2plugins&amp;type=$type'>"._("try again")."</a>");
        echo "</p></div>\n";
    } else {
        echo "<p>"._("Module uploaded successfully. You need to enable it globally or assign it to fop2 users to make it available.")."</p>\n";
    }

} else if($action=='delplugin') {
    //list ( $rawname, $nada) = preg_split("/-/",$itemid,2);
    $itemid = preg_replace("/[^A-Za-z0-9\._-]/","",$itemid);
    $rawname = $itemid;
    $deldir = substr(escapeshellarg($amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/plugins/$rawname"),1,-1);
    fop2_rrmdir($deldir);
    $results = sql( "DELETE FROM fop2plugins WHERE rawname='".$db->escapeSimple($rawname)."'");
    $results = sql( "DELETE FROM fop2UserPlugin WHERE id_plugin='".$db->escapeSimple($rawname)."'");
    needreload();
} else if ($action=='setglobal') {
    $rawname = $_REQUEST['fop2plugin'];
    $enabled = $_REQUEST['fop2globalenabled'];
    sql("UPDATE fop2plugins SET global='".$db->escapeSimple($enabled)."' WHERE rawname='".$db->escapeSimple($rawname)."'");
    needreload();
    exit;
} else if ($action=='saveField') {
    $field   = $_REQUEST['field'];
    $value   = $_REQUEST['value'];
    list ($rawname,$fieldname,$section) = preg_split("/-/",$field,3);
    $inifile = $amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/plugins/$rawname/$rawname.ini";
    if(file_exists($inifile)) {
        $ini_array = parse_ini_file($inifile, true);
    }
    if($section=='default') {
        $ini_array[$fieldname]=$value;
    } else {
        $ini_array[$section][$fieldname]=$value;
    }

    $res = array();
    foreach($ini_array as $key => $val)
    {
        if(is_array($val))
        {
            $res[] = "[$key]";
            foreach($val as $skey => $sval) $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
        }
        else $res[] = "$key = ".(is_numeric($val) ? $val : '"'.$val.'"');
    }
    file_put_contents($inifile, implode("\r\n", $res), LOCK_EX);
} else if ($action=='savePluginConfig') {
    $rawname = $_REQUEST['plugin'];
    $inifile = $amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/plugins/$rawname/$rawname.ini";
    $ini_array = array();
    foreach($_REQUEST as $key=>$val) {
        if(preg_match("/$rawname/",$key)) {
            list ($plug, $field, $section) = preg_split("/-/",$key);
            if($section=='default') {
                $ini_array[$field]=$val;
            } else {
                $ini_array[$section][$field]=$val;
            } 
        }
    }
    $res = array();
    foreach($ini_array as $key => $val)
    {
        if(is_array($val))
        {
            $res[] = "[$key]";
            foreach($val as $skey => $sval) $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
        }
        else $res[] = "$key = ".(is_numeric($val) ? $val : '"'.$val.'"');
    }
    file_put_contents($inifile, implode("\r\n", $res), LOCK_EX);
}

$plugin_online = getOnlinePlugins($fop2_mirror);
$plugin_local  = getInstalledPlugins();
$plugin_global = getGlobalPlugins();

$fpbx_version = preg_replace('/[^0-9]/','',getversion());

if($fpbx_version <= 290) {
    echo "\n</div>";
} 

$status="Upgrade Available";
?>

<div id="modulelist">
  <div class="category" id="category_Online">
  <h3> <?php echo _("FOP2 Repository - Available Plugins") ?> </h3>

<?php

    echo "<table style='border-collapse:collapse; width:100%;' class='fop2plugin'>"; 
    echo "<thead><tr><th>"._('Name')."</th><th>"._('Installed Version')."</th><th>"._('Available Version')."</th><th>"._('Globally Enabled')."</th><th></th></tr></thead>";
    echo "<tbody'>";
if (isset($plugin_online)) {

	foreach ($plugin_online as $idx=>$arrdata) {
        $rawname = $arrdata['rawname'];
        $name = $arrdata['name'];
        $version = $arrdata['version'];
        $description = $arrdata['description'];
        $price = intval($arrdata['price']);
        $installed_version ='';

        $partes = preg_split('/\./',$version);
        $superversion = $partes[0]*100000 + $partes[1]*1000 + $partes[2]*10;

        if(isset($plugin_local[$rawname])) {
            $installed_version = $plugin_local[$rawname];
            $partes = preg_split('/\./',$plugin_local[$rawname]);
            $superversionlocal = $partes[0]*100000 + $partes[1]*1000 + $partes[2]*10;
        } else {
            $superversionlocal = 0;
        }

        if(in_array($rawname,$licensedplugins)) { $paid=1; } else { $paid=0; }

        $mydis="";
        if($superversion == $superversionlocal) { 
            $delurl = $_SERVER['PHP_SELF'].'?display=fop2plugins&action=delplugin&itemid='.$rawname;
            $status = "<a class='btnbtn red' href='$delurl'>"._('Uninstall')."</a>";
        } else if($superversionlocal==0) {
            if($price==0 || ($price>0 && $paid==1)) {
                $mydis=" style='opacity: 0.7;' ";
                $geturl = $_SERVER['PHP_SELF'].'?display=fop2plugins&action=getplugin&itemid='.$rawname.'-'.$version;
                $status = "<a class='btnbtn' href='$geturl'>"._('Install')."</a>";
            } else {
                $geturl = 'http://www.fop2.com/buy.php';
                $status = "<a class='btnbtn ylw' href='$geturl'>"._('Buy')."</a>";
            }
        } else if($superversionlocal<$superversion) {
            $geturl = $_SERVER['PHP_SELF'].'?display=fop2plugins&action=getplugin&itemid='.$rawname.'-'.$version;
            $status = "<a class='btnbtn ylw' href='$geturl'>"._('Update')."</a>";
        }
        
        if(isset($plugin_global[$rawname])) { $checked=' checked '; } else { $checked=''; }
        if($price<=0) { $pr="<a class='btnbtn grn'>"._('Free')."</a>";} else { if($paid==1) { $pr="<a class='btnbtn' style='text-decoration:line-through;'>$".number_format($price,2)."</a>"; } else {$pr="<a class='btnbtn'>$".number_format($price,2)."</a>"; }}
        echo "<tr><td $mydis>$pr <strong>$name</strong></td>";
        echo "<td $mydis>$installed_version</td>";
        echo "<td $mydis>$version</td>";
        echo "<td $mydis><input id='global_".$rawname."' type='checkbox' $checked onclick='setGlobalPlugin(this);'/></td>";
        echo "<td  $mydis align='right'>$status</td>"; 
        echo "</tr>";
        echo "<tr><td $mydis colspan=5>$description</td></tr>";
        if($superversionlocal>0) {
            $configparams = getParamsForPlugin($rawname);
            if(count($configparams)>0) {
                echo "<tr><td colspan=5><hr/>";
                echo fop2_print_config_form($rawname);
                echo "</td></tr>";
            }
        }
        echo "<tr><td colspan=5 class='fop2pluginseparator'>&nbsp;</td></tr>";
    }
} else {
    echo "<tr><td colspan=5><span style='color:red; font-weight:bold;'>"._('Online Repository not reachable/accessible')."</span></td></tr>";
}
echo "</tbody></table></div></div>";

$plugname_online=array();
foreach ($plugin_online as $idx=>$arrdata) {
    $plugname_online[$arrdata['rawname']]=$arrdata['version'];
}
$locally_installed_not_online = array_diff_assoc($plugin_local, $plugname_online);

 echo "<div id='modulelistlocal'>
  <div class='category' id='category_Local'>
  <h3> "._("Locally Available Plugins")."</h3>";
if(count($locally_installed_not_online>0)) {

    echo "<table style='border-collapse:collapse; width:100%;' class='fop2plugin'>"; 
    echo "<thead><tr><th>"._('Name')."</th><th>"._('Installed Version')."</th><th>"._('Globally Enabled')."</th><th></th></tr></thead>";
    echo "<tbody'>";

	foreach ($locally_installed_not_online as $rawname=>$version) {

        $infoxml = substr(escapeshellarg($amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/plugins/$rawname/plugin.xml"),1,-1);

        if(is_readable($infoxml)) {
            $pluginxml = file_get_contents($infoxml);
            $xml = new xml2Array($pluginxml);
            $xmlarray = $xml->parseAdvanced($pluginxml);
            $data = $xmlarray['plugin'];
        } else {
            $data['rawname']=$rawname;
            $data['name']=$rawname;
            $data['version']=$version;
            $data['description']='';
        }
        $rawnamedb = $db->escapeSimple($data['rawname']);
        $namedb = $db->escapeSimple($data['name']);
        $versiondb = $db->escapeSimple($data['version']);
        $descriptiondb = $db->escapeSimple($data['description']);

        if(isset($plugin_global[$data['rawname']])) { $checked=' checked '; } else { $checked=''; }

        $results = sql( "INSERT INTO fop2plugins (rawname, name, version, description) values ('".$rawnamedb."','".$namedb."','".$versiondb."','".$descriptiondb."') ON DUPLICATE KEY UPDATE rawname='$rawnamedb', name='$namedb', version='$versiondb', description='$descriptiondb'");

        echo "<tr><td>".$data['name']."</td>";
        echo "<td>".$data['version']."</td>";
        echo "<td><input id='global_".$rawname."' type='checkbox' $checked onclick='setGlobalPlugin(this);'/></td>";
        echo "<td align='right'>-</td>"; 
        echo "</tr>";
        echo "<tr><td colspan=5>".$data['description']."</td></tr>";
        //if($superversionlocal>0) {
            $configparams = getParamsForPlugin($rawname);
            if(count($configparams)>0) {
                echo "<tr><td colspan=5><hr/>";
                echo fop2_print_config_form($rawname);
                echo "</td></tr>";
            }
        //}
        echo "<tr><td colspan=5 class='fop2pluginseparator'>&nbsp;</td></tr>";
    }

    echo "</tbody></table>";

}	
?>
  </div>
</div>
<hr/>
<div id='uploadplugin'>
  <div class='category' id='category_upload'>
  <h3> <?php echo _("Upload Plugin"); ?></h3>
<p><?php echo _('You can upload a tar gzip file containing a FOP2 plugin from your local system. If a plugin with the same name already exists, it will be overwritten.'); ?></p>
<br/>
<form name="plugin-upload" action="config.php" method="post" enctype="multipart/form-data"><input type="hidden" name="display" value="fop2plugins" /><input type="hidden" name="type" value="tool" /><input type="hidden" name="action" value="upload" /><input type="file" name="uploadplug" /> &nbsp;&nbsp; <input type="submit" value="Upload" /></form>

  </div>
</div>
